/*
 * actB.cpp
 * Contains definitions for checking action Bs.
 *
 * Copyright 2005-2006 by Dale McCoy.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include<fstream>
#include<string>

using namespace std;

#include"renum.h"
#include"inlines.h"
#include"sanity_defines.h"
#include"messages.h"
#include"data.h"
#include"strings.h"

class B:public Guintp{
public:
    uint maxSeverity,numMessages;
    SINGLETON(B);
};

B::B(){
    FILE*pFile=myfopen(B);
    maxSeverity=GetCheckByte(B);
    _p=new uint[numMessages=GetCheckByte(B)];
    for(uint i=0;i<numMessages;i++)
        _p[i]=GetCheckByte(B);
    fclose(pFile);
}

void CheckB(PseudoSprite&data){
    const uint sev=data.ExtractByte(1),lang=data.ExtractByte(2),messageid=data.ExtractByte(3);
    uint offset=4;
    int specials;
    if((sev&0x7F)>B::Instance().maxSeverity)IssueMessage(ERROR,INVALID_SEVERITY);
    if(lang&0x80||(lang&0x20&&!(lang&0x40)))IssueMessage(WARNING3,UNKNOWN_LANG_BIT);
    if(messageid!=0xFF&&messageid>=B::Instance().numMessages){
        IssueMessage(FATAL,INVALID_MESSAGEID);
        return;
    }
    if(messageid==0xFF)
        specials=CheckString(data,offset,CTRL_NEWLINE,MakeStack(4,STACK_TEXT,STACK_TEXT,STACK_DWORD,STACK_DWORD),RETURN_STACK);
    else
        specials=B::Instance()[messageid];
    if(specials==-1)return;
    if(specials>1){
        try{
            if(messageid==0xFF&&data.ExtractByte(offset))data.SetEol(offset-1);
        }catch(uint){}
        CheckString(data,offset,CTRL_NEWLINE);
    }
    if(specials>2&&data.ExtractByte(offset++)>0x7F)IssueMessage(ERROR,INVALID_PARAM,offset);
    if(specials>3&&data.ExtractByte(offset++)>0x7F)IssueMessage(ERROR,INVALID_PARAM,offset);
    if(offset!=data.Length())IssueMessage(WARNING2,EXTRA_DATA,offset);
}
